Program TPrint;
{$M 16384,0,0}
Uses CRT, DOS, ProfText, S_Input, Drives, FPrinter;

Const
  NCFG  = 'TPRINT.CFG';
  NFNT  = 'TPRINT.FNT';
  DIt   = '<>';
  BSize = 16384;
  FMax  = 500;
  CBold = false;
  NCh   = ' ࠭';

Type
  TCFG = Record
    LPT,
    LS,
    SPP,
    Num  : Byte;
    Zero : Boolean;
    Edit : String;
  End;
  FFRec = Record
    Name : String[12];
    Dir : Boolean
  End;

Var
  Valid : Array [1..3] of Boolean;
  P1st  : Byte;
  Font  : Array [0..255,0..15] of Byte;
  GBuf  : Array [0..959] of Byte;
  Page  : Array [0..79] of String;
  CFG   : TCFG;
  FFile : Array [0..FMax-1] of FFRec;
  FCnt  : Word;
  Dir,
  Name,
  DirE,
  NameE : String;
  F     : File;
  Readed: Word;
  Buf   : Array [0..BSize-1] of Char;
  BPos  : Word;
  FBOF,
  FEOF  : Boolean;
  Old1C : Pointer;

Function GetPath : String;
Var S : String;
Begin
  S := ParamStr(0);
  While S[Length(S)] <> '\' do Dec(S[0]);
  GetPath := S
End;

Function Exist (N : String) : Boolean;
Var F : File;
Begin
  Assign (F, N);
  {$I-} Reset (F); {$I+}
  If IOResult <> 0 then Exist := False
  Else
    Begin
      {$I-} Close (F); {$I+}
      Exist := True
    End
End;

Procedure LoadCFG;
Var F : File of TCFG;
Begin
  If Exist (GetPath+NCFG) then
    Begin
      Assign (F, GetPath+NCFG);
      Reset (F);
      Read (F, CFG);
      Close (F)
    End
  Else
    Begin
      CFG.LPT := 1;
      CFG.LS := 0;
      CFG.SPP := 64;
      CFG.Num := 0;
      CFG.Zero := True
    End;
  GetDir (0, Dir);
  If Dir[Length(Dir)] <> '\' then Dir := Dir + '\';
  Name := NCh;
  NameE := CFG.Edit;
  DirE := CFG.Edit;
  While Pos('\', NameE) > 0 do NameE := Copy(NameE, 2, Length(NameE)-1);
  While (DirE <> '') and (DirE[Length(DirE)] <> '\') do Dec (DirE[0]);
  If NameE = '' then NameE := NCh
End;

Procedure SaveCFG;
Var F : File of TCFG;
Begin
  Assign (F, GetPath+NCFG);
  {$I-} Rewrite (F); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} Write (F, CFG);
  Close (F) {$I+}
End;

Procedure LoadFont;
Var F : File;
Begin
  Assign (F, NFNT);
  {$I-} Reset (F, 1); {$I+}
  If IOResult <> 0 then
    Begin
      WriteLn (' '+NFNT+'  ⮬ ਭ  !');
      Halt
    End;
  {$I-} BlockRead (F, Font, SizeOf(Font)); {$I+}
  If IOResult <> 0 then
    Begin
      WriteLn ('訡 ⥭ 䠩 '+NFNT+'  ⮬ ਭ!');
      Halt
    End;
  {$I-} Close (F) {$I+}
End;

Procedure Color (B, T : Byte);
Begin
  TextBackGround (B);
  TextColor (T)
End;

Function Hex (W : Word) : String;
Const
  HC : Array [0..15] of Char = '0123456789ABCDEF';
Begin
  Hex := HC[Hi(W) shr 4] + HC[Hi(W) and 15] +
       HC[Lo(W) shr 4] + HC[Lo(W) and 15]
End;

Procedure Window (X, Y, L, H : Byte; Name : String; B, T : Byte);
Var
  Min, Max : Word;
  I, J : Byte;
Begin
  Color (B, T);
  Min := WindMin;
  Max := WindMax;
  CRT.Window (X, Y, X+L-1, Y+H-1);
  ClrScr;
  CRT.Window (Lo(Min)+1, Hi(Min)+1, Lo(Max)+1, Hi(Max)+1);
  GotoXY (X+2, Y+1); Write ('');
  GotoXY (X+2, Y+H-2); Write ('');
  GotoXY (X+L-3, Y+1); Write ('');
  GotoXY (X+L-3, Y+H-2); Write ('');
  For I := X+3 to X+L-4 do
    Begin
      GotoXY (I, Y+1); Write ('');
      GotoXY (I, Y+H-2); Write ('')
    End;
  For J := Y+2 to Y+H-3 do
    Begin
      GotoXY (X+2, J); Write ('');
      GotoXY (X+L-3, J); Write ('')
    End;
  GotoXY (X+(L-Length(Name)) div 2-1, Y+1);
  Write (' '+Name+' ');
  Color (Black, Black);
  For J := Y+1 to Y+H do
    Begin
      GotoXY (X+L, J);
      Write ('')
    End;
  For I := X+2 to X+L do
    Begin
      GotoXY (I, Y+H);
      Write ('')
    End;
  Color (B, T)
End;

{$F+}
Procedure Int1C; Interrupt;
Var
  CX, CY, C, SB : Byte;
Begin
  CX := WhereX; CY := WhereY; C := TextAttr;
  SB := PrnStatus;
  Color (LightGray, Black);
  GotoXY (1, 25);
  If SB and $80 = 0 then
    Write (' -   ')
  Else
    Write (' ---------  ');
  If SB and $20 = 0 then
    Write ('----------  ')
  Else
    Write (' 㬠  ');
  If SB and $10 = 0 then
    Write ('- 몫祭  ')
  Else
    Write ('------------  ');
  If SB and 8 = 0 then
    Write ('訡 -')
  Else
    Write ('-----------');
  TextAttr := C; GotoXY (CX, CY)
End;
{$F-}

Function ReadChar : Char;
Var
  C : Char;
  P : Pointer;
Begin
  FEOF := False;
  C := Buf[BPos];
  Inc (BPos);
  If BPos = Readed then
    If BPos < BSize then FEOF := True
    Else
      Begin
        {$I-} BlockRead (F, Buf, BSize, Readed); {$I+}
        If IOResult <> 0 then
          Begin
            GetIntVec ($1C, P);
            If P = @Int1C then SetIntVec ($1C, Old1C);
            Color (Black, LightGray);
            WriteLn ('訡 ⥭ 䠩 '+Name+' !');
            Halt
          End;
        BPos := 0;
        If Readed = 0 then FEOF := True
      End;
  ReadChar := C
End;

Function ReadBChar : Char;
Var
  P : Pointer;
  Z : LongInt;
Label L;
Begin
  FBOF := False;
  Dec (BPos);
  If BPos = 65535 then begin
    {$I-} Z := FilePos(F); {$I+}
    If IOResult <> 0 then Goto L;
    If Z <= BSize then
      Begin
        FBOF := True;
        Inc (BPos)
      End
    Else
      Begin
        {$I-}
        If Z mod BSize = 0 then
          Seek (F, Z-2*BSize)
        Else
          Seek (F, Z-BSize-(Z mod BSize));
        {$I+}
        If IOResult <> 0 then Goto L;
        {$I-} BlockRead (F, Buf, BSize, Readed); {$I+}
        If IOResult <> 0 then
          Begin
L:
            GetIntVec ($1C, P);
            If P = @Int1C then SetIntVec ($1C, Old1C);
            Color (Black, LightGray);
            WriteLn ('訡 ⥭ 䠩 '+Name+' !');
            Halt
          End;
        BPos := BSize-1
      End;
  end;
  ReadBChar := Buf[BPos]
End;

Function ReadStr : String;
Var
  C : Char;
  S : String;
Begin
  S := '';
  Repeat
    C := ReadChar;
    If C <> #13 then
      S := S + C
    Else
      Begin
        ReadChar;
        Break
      End;
  Until FEOF;
  If FEOF and (S[Length(S)] = #26) then Dec(S[0],1);
  ReadStr := S
End;

Function ReadBStr : String;
Var
  S : String;
  C : Char;
Begin
  S := '';
  ReadBChar; ReadBChar;
  If not FBOF then
  Repeat
    C := ReadBChar;
    If C = #10 then
      Begin
        If not FBOF then ReadChar;
        Break
      End
    Else S := C + S
  Until FBOF;
  ReadBStr := S
End;

Function ContRange (S : String; Cmin, Cmax : Char) : Boolean;
Var
  I : Byte;
  F : Boolean;
Begin
  F := False;
  If S <> '' then
    For I := 1 to Length(S) do
      If S[I] In [Cmin..Cmax] then
        Begin
          F := True;
          Break
        End;
  ContRange := F
End;

Procedure PrnGS (S : String; Bold : Boolean);
Var
  GP,
  I, J, L : Word;
Begin
  PrnHome; If SendError then Exit;
  If LSpace > 0 then
    For I := 1 to LSpace do S := ' ' + S;
  If S <> '' then
    While S[Length(S)] = ' ' do Dec (S[0]);
  If S <> '' then
    Begin
      For I := 0 to Length(S)-1 do
        For J := 0 to 11 do
          GBuf[I*12+J] := Font[Ord(S[I+1]),J];
      L := Length(S)*12;
      Prn960 (L); If SendError then Exit;
      For I := 0 to L-1 do
        Begin
          PrnSend (Chr(GBuf[I])); If SendError then Exit
        End;
      If Bold then
        Begin
          Prn216 (1); If SendError then Exit;
          PrnLF; If SendError then Exit;
          PrnHome; If SendError then Exit;
          Prn960 (L); If SendError then Exit;
          For I := 0 to L-1 do
            Begin
              PrnSend (Chr(GBuf[I])); If SendError then Exit
            End;
          Prn216 (LHeight); If SendError then Exit
        End;
      If (LHeight > 24) and ContRange (S, #$B3, #$DA) then
        Begin
          For I := 0 to Length(S)-1 do
            For J := 0 to 11 do
              If S[I+1] in [#$B3..#$DA] then
                GBuf[I*12+J] := GBuf[I*12+J] shl 7
              Else GBuf[I*12+J] := 0;
          Prn216 (24); If SendError then Exit;
          PrnLF; If SendError then Exit;
          GP := LHeight - 24;
          If GP mod 24 <> 0 then
            Begin
              For I := 0 to L-1 do
                If GBuf[I] <> 0 then
                  GBuf[I] := $FF shl (8 - (GP mod 24) div 3);
              PrnHome; If SendError then Exit;
              Prn960 (L); If SendError then Exit;
              For I := 0 to L-1 do
                Begin
                  PrnSend (Chr(GBuf[I])); If SendError then Exit
                End;
              If Bold then
                Begin
                  Prn216 (1); If SendError then Exit;
                  PrnLF; If SendError then Exit;
                  PrnHome; If SendError then Exit;
                  Prn960 (L); If SendError then Exit;
                  For I := 0 to L-1 do
                    Begin
                      PrnSend (Chr(GBuf[I])); If SendError then Exit
                    End;
                End;
              Prn216 (GP mod 24); If SendError then Exit;
              PrnLF; If SendError then Exit
            End;
          If GP div 24 <> 0 then
            Begin
              For I := 0 to L-1 do
                If GBuf[I] <> 0 then GBuf[I] := $FF;
              Prn216 (24); If SendError then Exit;
              For J := 1 to GP div 24 do
                Begin
                  PrnHome; If SendError then Exit;
                  Prn960 (L); If SendError then Exit;
                  For I := 0 to L-1 do
                    Begin
                      PrnSend (Chr(GBuf[I])); If SendError then Exit
                    End;
                  If Bold then
                    Begin
                      Prn216 (1); If SendError then Exit;
                      PrnLF; If SendError then Exit;
                      PrnHome; If SendError then Exit;
                      Prn960 (L); If SendError then Exit;
                      For I := 0 to L-1 do
                        Begin
                          PrnSend (Chr(GBuf[I])); If SendError then Exit
                        End;
                      Prn216 (24); If SendError then Exit
                    End;
                  PrnLF; If SendError then Exit;
                End;
            End;
          Prn216 (LHeight)
        End
      Else
        PrnLF
    End
  Else
    PrnLF
End;

Procedure Print;
Const
  WX = 1;
  WY = 3;
  WH = 20;
Var
  PGN : Word;
  PGH : Byte;
  PGS : Byte;
  C   : Char;
  I   : Byte;
Function Tab2Space (S : String) : String;
Var I, J : Byte;
Begin
  If S <> '' then
    Begin
      I := 1;
      Repeat
        If S[I] = #9 then
          Begin
            S[I] := ' ';
            If (I-1) mod 8 < 7 then
              For J := 1 to 7 - ((I-1) mod 8) do
                Insert (' ', S, I)
          End;
        Inc (I)
      Until I > Length(S)
    End;
  Tab2Space := S
End;
Procedure WPage;
Var I : Byte;
Procedure Write2 (S : String);
Var I, X, Y : Byte; Sg : Word;
Begin
  If S = '' then Exit;
  Sg := $B800;
  If (Mem[0:$410] and $30) = $30 then Sg := $B000;
  X := WhereX-1; Y := WhereY-1;
  For I := 0 to Length(S)-1 do
    Begin
      MemW[Sg:((Y*80)+X) shl 1] := Ord(S[I+1]) + (TextAttr shl 8);
      Inc (X)
    End;
  If X = 80 then Begin X := 0; Inc (Y) End;
  GotoXY (X+1, Y+1)
End;
Begin
  For I := 0 to WH-1 do
    Begin
      GotoXY (WX, WY+I); ClrEol;
      If PGS+I < PGH then Write2 (Copy(Tab2Space(Page[PGS+I]),1,80))
    End;
  GotoXY (68, WY-2); Write ('࠭:', PGN:4)
End;
Procedure ReadPage;
Begin
  If FEOF then Exit;
  PGH := 0;
  While (PGH < CFG.SPP) and not FEOF do
    Begin
      Page[PGH] := ReadStr;
      Inc (PGH)
    End;
  Inc (PGN);
  PGS := 0
End;
Procedure ReadBPage;
Var
  I   : Byte;
Begin
  If PGN = 1 then Exit;
  For I := 1 to PGH do
    ReadBStr;
  For I := 1 to CFG.SPP do
    ReadBStr;
  For I := 0 to CFG.SPP-1 do
    Page[I] := ReadStr;
  PGH := CFG.SPP;
  Dec (PGN);
  PGS := 0
End;
Function Zero2O (S : String) : String;
Var I : Byte;
Begin
  If not CFG.Zero then
    If S <> '' then
      For I := 1 to Length(S) do
        If S[I] = '0' then S[I] := 'O';
  Zero2O := S
End;
Procedure Error (E : Boolean);
Begin
  GotoXY (58, 25);
  If E then
    Begin
      Write ('訡 ਭ      ');
      While not (ReadKey in [#13,#27,#32]) do;
      GotoXY (58, 25);
      Write ('樠 -...');
      If not PrnInit then
        Begin
          GotoXY (58, 25);
          Write ('訡 ਭ      ');
          While not (ReadKey in [#13,#27,#32]) do;
        End;
      Error (False)
    End
  Else
    ClrEol
End;
Label LCyc, LK, LEK;
Var S : String;
Begin
  Color (LightGray, Black);
  ClrScr;
  Assign (F, Dir+Name);
  FileMode := 0;
  Reset (F, 1);
  If FileSize(F) = 0 then
    Begin
      Close (F);
      Exit
    End;
  {$I-} BlockRead (F, Buf, BSize, Readed); {$I+}
  If IOResult <> 0 then
    Begin
      Color (Black, LightGray);
      WriteLn ('訡 ⥭ 䠩 '+Name+' !');
      Halt
    End;
  BPos := 0;
  PGN := 0;
  FEOF := False;
  ReadPage;
  GotoXY (WX, WY-2); Write (': ',Dir+Name);
  For I := 0 to 79 do
    Begin
      GotoXY (WX+I, WY-1); Write ('');
      GotoXY (WX+I, WY+WH); Write ('')
    End;
  GotoXY (WX, WY+WH+1);
  Write (' Esc-  P,F10-  '#24','#25',PgUp,PgDn,-஫뢠');
  WPage;
  SetIntVec ($1C, @Int1C);
  Error (False);
  Repeat
LCyc:
    If KeyPressed then C := ReadKey
    Else C := #$FF;
LK:
    If C = #27 then Break;
    If UpCase(C) = 'P' then
      Begin
        PrnClearBuf;
        If SendError then
          Begin
            Error (True);
            Goto LCyc
          End;
        If CFG.Num = 0 then
          LHeight := 2303 div (CFG.SPP+2)
        Else
          LHeight := 2303 div (CFG.SPP+4);
        Prn216 (LHeight);
        If SendError then
          Begin
            Error (True);
            Goto LCyc
          End;
        LSpace := 0;
        PrnLF;
        If SendError then
          Begin
            Error (True);
            Goto LCyc
          End;
        If CFG.Num = 1 then
          Begin
            Str (PGN, S);
            S := '-'+S+'-';
            While Length(S) < 80 do S := ' '+S+' ';
            While S[Length(S)] = ' ' do Dec(S[0]);
            Delete (S,1,1);
            PrnGS (Zero2O(S), CBold);
            If SendError then
              Begin
                Error (True);
                Goto LCyc
              End;
            PrnLF;
            If SendError then
              Begin
                Error (True);
                Goto LCyc
              End
          End;
        LSpace := CFG.LS;
        For I := 0 to PGH-1 do
          Begin
            PrnGS (Tab2Space(Zero2O(Copy(Page[I],1,80))), CBold);
            If SendError then
              Begin
                Error (True);
                Goto LCyc
              End;
{            If KeyPressed then C := ReadKey
            Else C := #$FF;
            If C = #27 then
              Begin
                PrnClearBuf;
                If SendError then Error (True);
                Goto LCyc
              End}
          End;
        LSpace := 0;
        If CFG.Num = 2 then
          Begin
            Str (PGN, S);
            S := '-'+S+'-';
            While Length(S) < 80 do S := ' '+S+' ';
            While S[Length(S)] = ' ' do Dec(S[0]);
            Delete (S,1,1);
            If PGH+2 < CFG.SPP then
              For I := PGH+3 to CFG.SPP do
                Begin
                  PrnLF;
                  If SendError then
                    Begin
                      Error (True);
                      Goto LCyc
                    End;
{                  If KeyPressed then C := ReadKey
                  Else C := #$FF;
                  If C = #27 then
                    Begin
                      PrnClearBuf;
                      If SendError then Error (True);
                      Goto LCyc
                    End}
                End;
            PrnLF;
            If SendError then
              Begin
                Error (True);
                Goto LCyc
              End;
            PrnGS (Zero2O(S), CBold);
            If SendError then
              Begin
                Error (True);
                Goto LCyc
              End
          End;
        PrnHome;
        If SendError then
          Begin
            Error (True);
            Goto LCyc
          End;
        PrnFF;
        If SendError then
          Begin
            Error (True);
            Goto LCyc
          End;
        Prn216 (36);
        If SendError then
          Begin
            Error (True);
            Goto LCyc
          End;
        PrnClearBuf;
        If SendError then
          Begin
            Error (True);
            Goto LCyc
          End;
        C := #81;
        Goto LEK
      End;
    If C = #0 then
      Begin
        C := ReadKey;
LEK:
        Case C of
          #68 : Begin C := 'P'; Goto LK End;
          #72 : If PGS > 0 then Begin Dec (PGS); WPage End;
          #80 : If (PGH > WH) and (PGH-WH-PGS > 0) then
                  Begin Inc (PGS); WPage End;
          #73 : Begin
                  ReadBPage;
                  WPage
                End;
          #81 : Begin
                  ReadPage;
                  WPage
                End;
        End
      End;
  Until False;
  SetIntVec ($1c, Old1C);
  Close (F);
  FileMode := 2;
  Color (LightGray, Black);
  ClrScr
End;

Function DF_EN (Path : PathStr; D : Boolean) : String;
Var
  Dir  : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
  S    : String;
Begin
  If Pos(':',Path) = 0 then
    FSplit (Path, Dir, Name, Ext)
  Else
    Begin
      Ext := '';
      Name := Path
    End;
  S := Ext;
  While Length (S) < 4 do S := S + ' ';
  S := S + Name;
  If D then S := '2' + S
  Else S := '3' + S;
  If Path = DIt then S := '0';
  If Path = '..' then S := '1';
  DF_EN := S
End;

Function LessExtName (X, Y : FFRec) : Boolean;
Begin
  LessExtName := DF_EN (X.Name, X.Dir) < DF_EN (Y.Name, Y.Dir)
End;

Procedure QuickSort (L, R : Integer);
Var
  I, J : Integer;
  X, Y : FFRec;
Begin
  I := L;
  J := R;
  X := FFile[(L + R) div 2];
  Repeat
    While LessExtName (FFile[I], X) do Inc(I);
    While LessExtName (X, FFile[J]) do Dec(J);
    If I <= J then
      Begin
        Y := FFile[I];
        FFile[I] := FFile[J];
        FFile[J] := Y;
        Inc(I);
        Dec(J)
    End;
  Until I > J;
  If L < J then QuickSort (L, J);
  If I < R then QuickSort (I, R);
End;

Procedure SortFiles;
Begin
  If FCnt <> 0 then QuickSort (0, FCnt - 1)
End;

Procedure SelectFile (Var FDir, Name : String; EXE : Boolean);
Const
  WX = 12; WY = 8; FH = 10;
Var
  WF, WS : Word;
  CurDir : String;
Procedure WL;
Var I : Byte;
Begin
  For I := 0 to FH-1 do
    Begin
      GotoXY (WX+13, WY+I); Write ('');
      GotoXY (WX+28, WY+I); Write ('');
      GotoXY (WX+43, WY+I); Write ('')
    End
End;
Procedure WW;
Var I : Byte;
Function FN (N : Word) : String;
Var S : String; I : Byte;
Begin
  S := FFile[N].Name;
  If not FFile[N].Dir then
    For I := 1 to Length(S) do
      If S[I] in ['A'..'Z'] then Inc (S[I], Ord('a')-Ord('A'));
  If S <> '..' then
    Begin
      If Pos('.',S) = 0 then S := S + '.';
      While Pos('.',S) < 9 do Insert (' ',S,Pos('.',S))
    End;
  While Length(S) < 12 do S := S + ' ';
  S[9] := ' ';
  FN := S
End;
Begin
  For I := 0 to 4*FH-1 do
    Begin
      If I = WS then Color (Black, LightGray)
      Else Color (LightGray, Black);
      GotoXY (WX + 15*(I div FH), WY + I mod FH);
      If WF+I < FCnt then Write (FN(WF+I))
      Else Write ('':12);
    End
End;
Procedure FFind;
Var
  S : SearchRec;
  DS : String;
Label L;
Begin
  If Pos(DIt,CurDir) > 0 then
    Begin
      DS := DOSDrives;
      For FCnt := 1 to Length(DS) do
        Begin
          FFile[FCnt-1].Name := DS[FCnt] + ':';
          FFile[FCnt-1].Dir := True
        End;
      FCnt := Length(DS);
      SortFiles;
      Exit
    End;
  FFile[0].Name := DIt;
  FFile[0].Dir := True;
  FCnt := 1;
  FindFirst (CurDir+'*.*',anyfile-volumeid,s);
  While (DOSError = 0) and (FCnt <= FMax) do
    Begin
      If (S.Name <> '.') then
        Begin
          If (S.Attr and directory = 0) and
            not (EXE xor (Pos('.COM',S.Name) + Pos('.EXE',S.Name) = 0)) then
              Goto L;
          FFile[FCnt].Name := S.Name;
          FFile[FCnt].Dir := S.Attr and directory <> 0;
          Inc (FCnt)
        End;
L:
      FindNext (S)
    End;
  SortFiles
End;
Procedure Up;
Begin
  If FCnt = 0 then Exit;
  If WS > 0 then Dec (WS)
  Else If WF > 0 then Dec (WF)
End;
Procedure Down;
Begin
  If FCnt = 0 then Exit;
  If WF+WS+1 < FCnt then
    If WS < FH*4-1 then Inc (WS)
    Else Inc (WF)
End;
Var
  C : Char;
  I : Byte;
  SUD : String;
Begin
  Color (LightGray, Black);
  ClrScr;
  SUD := '';
  CurDir := Dir;
  FFind;
  WF := 0;
  WS := 0;
  Down;
  Window (WX-4,WY-2,15*4+5,FH+4,CurDir,LightGray,Black);
  WL;
  WW;
  Repeat
    If KeyPressed then C := ReadKey
    Else C := #$FF;
    If C = #27 then Break;
    If C = #13 then
      If not FFile[WF+WS].Dir then
        Begin
          FDir := CurDir;
          Name := FFile[WF+WS].Name;
          Break
        End
      Else
        Begin
          If Pos(':',FFile[WF+WS].Name) > 0 then
            CurDir := FFile[WF+WS].Name + '\'
          Else If FFile[WF+WS].Name = DIt then
            CurDir := DIt
          Else If FFile[WF+WS].Name <> '..' then
            CurDir := CurDir + FFile[WF+WS].Name + '\'
          Else
            Begin
              Dec (CurDir[0]);
              While CurDir[Length(CurDir)] <> '\' do
                Begin
                  SUD := CurDir[Length(CurDir)] + SUD;
                  Dec (CurDir[0])
                End
            End;
          FFind;
          WF := 0;
          WS := 0;
          If SUD <> '' then
            Begin
              While FFile[WF+WS].Name <> SUD do Down;
              SUD := ''
            End
          Else
            If Pos(DIt,CurDir) = 0 then Down;
          Window (WX-4,WY-2,15*4+5,FH+4,CurDir,LightGray,Black);
          WL;
          WW
        End;
    If C = #0 then
      Begin
        C := ReadKey;
        Case C of
          #72: Begin Up; WW End;
          #80: Begin Down; WW End;
          #75: Begin For I := 1 to FH do Up; WW End;
          #77: Begin For I := 1 to FH do Down; WW End;
          #71: Begin WF := 0; WS := 0; WW End;
          #79: Begin If FCnt > 0 then While WF+WS < FCnt-1 do Down; WW End;
        End
      End;
  Until False;
  Color (LightGray, Black);
  ClrScr;
End;

Procedure Main;
Const
  MX = 26; MY = 9;
  MN = 9;
Var
  C : Char;
  It: Byte;
Procedure WM (N : Byte);
Const
  MIt : Array [0..MN] of String[20] =
  (' ਭ LPT:',
   '  (ᨬ):',
   ' ભ :',
   'ப  ࠭:',
   '㬥 ࠭:',
   '⠥   䠩:',
   '',
   '         :',
   '஢',
   '室');
Var
  I : Byte;
Begin
  For I := 0 to MN do
    Begin
      If I = N then Color (Black, LightGray)
      Else Color (LightGray, Black);
      GotoXY (MX-1, MY+I); Write (' ', MIt[I], ' ');
      Case I of
        0 : Write (CFG.LPT);
        1 : Write (CFG.LS);
        2 : If CFG.Zero then Write ('') Else Write ('');
        3 : Write (CFG.SPP);
        4 :
          Case CFG.Num of
            0 : Write ('');
            1 : Write ('');
            2 : Write ('')
          End;
        5 : Write (Name);
        7 : Write (NameE);
      End;
      While WhereX < MX+32 do Write (' ')
    End;
End;
Var
  B : Byte;
  E : Integer;
  S : String;
Label
  R0, Refr, Upd;
Begin
  It := 5;
R0:
  CursorOff;
  Color (LightGray, Black);
  ClrScr;
Refr:
  Window (MX-5, MY-2, 41, 5+MN, 'ணࠬ ', LightGray, Black);
Upd:
  WM (It);
  Repeat
    If KeyPressed then C := ReadKey
    Else C := #$FF;
    If C = #13 then
      Begin
        Case It of
          0:
            Begin
              WM (255);
              GotoXY (MX+19, MY);
              CursorOn (6, 7);
              Str (CFG.LPT, S);
              ReadSK (S, 1);
              CursorOff;
              Val (S, B, E);
              If (E = 0) and (B > 0) and (B < 4) and
                Valid[B] then CFG.LPT := B;
              Goto Upd
            End;
          1:
            Begin
              WM (255);
              GotoXY (MX+19, MY+1);
              CursorOn (6, 7);
              Str (CFG.LS, S);
              ReadSK (S, 3);
              CursorOff;
              Val (S, B, E);
              If (E = 0) and (B < 80) then CFG.LS := B;
              Goto Upd
            End;
          2:
            Begin
              CFG.Zero := not CFG.Zero;
              Goto Upd
            End;
          3:
            Begin
              WM (255);
              GotoXY (MX+19, MY+3);
              CursorOn (6, 7);
              Str (CFG.SPP, S);
              ReadSK (S, 3);
              CursorOff;
              Val (S, B, E);
              If (E = 0) and (B >= 40) and (B <= 80) then CFG.SPP := B;
              Goto Upd
            End;
          4:
            Begin
              Inc (CFG.Num);
              If CFG.Num > 2 then CFG.Num := 0;
              Goto Upd
            End;
          5: SelectFile (Dir, Name, False);
          6: If Exist (Dir+Name) then
               Begin
                 CurLPT := CFG.LPT;
                 Print
               End;
          7:
             Begin
               SelectFile (DirE, NameE, True);
               If NameE <> NCh then
                 CFG.Edit := DirE+NameE
             End;
          8:  If (CFG.Edit <> '') and Exist (CFG.Edit) and
                  Exist (Dir+Name) then
                Begin
                  Color (Black, LightGray);
                  ClrScr;
                  CursorOn (6, 7);
                  Exec (CFG.Edit, Dir+Name);
                  Goto R0;
                End;
          9: Break
        End;
        Goto Refr;
      End;
    If C = #0 then
      Begin
        C := ReadKey;
        Case C of
          #72: If It > 0 then Begin Dec (It); WM (It) End;
          #80: If It < MN then Begin Inc (It); WM (It) End;
        End;
      End;
  Until False;
  Color (Black, LightGray);
  ClrScr;
  CursorOn (6, 7)
End;

Var I : Byte;

Begin
  GetIntVec ($1C, Old1C);
  LoadFont;
  LoadCFG;
  Color (Black, LightGray);
  ClrScr;
  P1st := 0;
  If not LPTPresent(0) then
    Begin
      WriteLn ('  ⮢ ਭ (LPT)  㦥!');
      Exit
    End
  Else
    For I := 1 to 3 do
      If LPTPresent(I) then
        Begin
          Write ('LPT',Chr(I+48),'=',Hex(PLPT[I]),'  ');
          Write (' ਭ...');
          CurLPT := I;
          Valid[I] := PrnInit;
          GotoXY (WhereX-17, WhereY);
          If not Valid[I] then
            WriteLn ('ਭ  㦥 (몫祭   ᮥ  '+
                                                         '஬)!')
          Else
            WriteLn ('㦥 ਭ.');
          If Valid[I] and (P1st = 0) then P1st := I
        End;
  If not (Valid[1] or Valid[2] or Valid[3]) then
    Begin
      WriteLn (#13#10'蠩 ஡.');
      Exit
    End;
  If not Valid[CFG.LPT] then CFG.LPT := P1st;
  Delay (2000);
  Main;
  SaveCFG
End.
